:::: Knabench 1.44 W32-W64 02/11/2007 by Kna
::::     Based on first idea and release
::::       by KWSN Chicken of Angnor,
::::   http://www.zadra.org/seti_enhanced/

@echo off & cls
echo.
echo = Knabench 1.44 W32-W64 02/12/2007 by Kna + Simon =
echo = mods: quick timetable, stderr, speedup/ratio    =
echo.

:::: OS VERSION CHECKING

if "%1%"=="OSOK" goto OSOK
VER | find "NT" > nul
IF %errorlevel% EQU 0 GOTO NT4
:OSOK
setlocal EnableDelayedExpansion
Setlocal EnableExtensions

:CLEANUP
if exist .\testDatas\*.sah del .\testDatas\*.sah
if exist .\testDatas\*.res del .\testDatas\*.res
del .\Testdatas\time.* .\Testdatas\elapsed.sec .\Testdatas\cur*.dat >NUL

:::: DETERMINING AVAILABLE TEST WUS IN \testWUs DIR
:::: and creating variables accordingly

if not exist .\testwus\*.wu goto NOWUS
set /a n=0
for /F %%a in ('dir /B /ON .\testwus\*.wu') do (
set /a n=!n!+1
set WUNBR!n!=%%a
)
set WUQTY=!n!
echo  %wuqty% testWU(s) found
for /L %%a in (1,1,10) do if defined wunbr%%a echo    (!wunbr%%a!)
goto CHKREF
:NOWUS
type .\tools\bel.dat
echo     NO test WU found in .\testWUs\
echo           ABORTING BENCHMARK
if exist .\testwus\test* echo Please rename WU(s) with .wu extension
echo.
goto EOF

:::: DETERMINING AVAILABLE REF SCIENCE APP IN \Science_apps\Reference DIR
:::: and creating variable accordingly

:CHKREF
set /a n=0
if not exist .\Science_apps\Reference\*.exe goto NOREFAPP
for /F %%a in ('dir /B .\Science_apps\Reference\*.exe') do (
set /a n=!n!+1
set REFAPP!n!=%%a
)
set REFQTY=!n!
echo.
echo  %refqty% reference science app(s) found
for /L %%a in (1,1,10) do if defined refapp%%a echo    (!refapp%%a!)
goto CHKSCAPP
:NOREFAPP
echo.
set REFQTY=0
echo  %refqty% reference science app(s) found
echo    (validating function is DISABLED)

:::: DETERMINING AVAILABLES SCIENCE APPS IN \Science_apps DIR
:::: and creating variables accordingly

:CHKSCAPP
if not exist .\Science_apps\*.exe goto NOSCAPP
set /a n=0
for /F %%a in ('dir /B /ON .\Science_apps\*.exe') do (
set /a n=!n!+1
set scapp!n!=%%a
)
set scqty=!n!
echo.
echo  %scqty% science app(s) found
for /L %%a in (1,1,10) do if defined scapp%%a echo    (!scapp%%a!)
goto LETSGO
:NOSCAPP
echo.
if "!n!"=="0" (type .\tools\bel.dat & echo  0 science app found, ABORTING BENCHMARK & echo. & goto EOF)
set scqty=0
echo  %scqty% science app(s) found

:LETSGO
echo.
echo ======================================
echo.

:::: STOPPING BOINC

echo Stopping Boinc ...
net stop boinc
echo ------------
echo ============ >.\testdatas\benchres.tmp
if exist .\testdatas\timetable.tmp del .\testdatas\timetable.tmp >NUL

FOR /L %%w IN (1,1,%WUQTY%) DO (

echo WU : !wunbr%%w! >>.\testdatas\timetable.tmp

rem :: RUNNING REFERENCE SCIENCE APP IF ANY
rem :: AND STORING RESULT FOR VALIDATION IF NEEDED

if "%REFQTY%"=="0" goto RUNSCAPPS
for /L %%r IN (1,1,%REFQTY%) DO (
echo Running app : !refapp%%r! with -verb -nog
echo with WU     : !wunbr%%w!
echo !refapp%%r! -verb -nog / !wunbr%%w! : >>.\testdatas\benchres.tmp
copy .\testwus\!wunbr%%w! .\science_apps\reference\work_unit.sah >NUL
copy /Y .\testwus\init_data.xml .\science_apps\reference\init_data.xml >NUL
if exist .\science_apps\reference\cpu_time.txt del .\science_apps\reference\cpu_time.txt >NUL
if exist .\science_apps\reference\stderr.txt del .\science_apps\reference\stderr.txt >NUL
if exist .\science_apps\reference\result.sah del .\science_apps\reference\result.sah >NUL
if exist .\science_apps\reference\state.sah del  .\science_apps\reference\state.sah >NUL
if exist .\science_apps\reference\boinc_finish_called del .\science_apps\reference\boinc_finish_called >NUL

.\tools\NOW hh:mm:ss'.'zzz >.\Testdatas\time.tmp
for /F %%a in ('type .\Testdatas\time.tmp') do set time_tmp=%%a
echo Started at  : !time_tmp!
echo Started at  : !time_tmp! >>.\testdatas\benchres.tmp
.\tools\stopwatch start >.\Testdatas\time.dat
pushd .\science_apps\reference\
!refapp%%r! -verb -nog
popd
.\tools\stopwatch stop < .\Testdatas\time.dat > .\Testdatas\elapsed.sec
.\tools\NOW hh:mm:ss'.'zzz >.\Testdatas\time.tmp
.\tools\wu_time .\science_apps\reference\init_data.xml

for /F %%a in ('type .\Testdatas\time.tmp') do set time_tmp=%%a
echo Ended at    : !time_tmp!
echo Ended at    : !time_tmp! >>.\testdatas\benchres.tmp
for /F %%a in ('type .\Testdatas\elapsed.sec') do set /a elapsed_time_stock=%%a
echo Elapsed time: !elapsed_time_stock! seconds
echo Elapsed time: !elapsed_time_stock! seconds >>.\testdatas\benchres.tmp
echo !refapp%%r! : !elapsed_time_stock! seconds >>.\testdatas\timetable.tmp
echo. >>.\testdatas\benchres.tmp

if not exist .\science_apps\reference\stderr.txt echo Stderr.txt  : not found >>.\testdatas\benchres.tmp
if exist .\science_apps\reference\stderr.txt echo [ stderr ]>>.\testdatas\benchres.tmp
if exist .\science_apps\reference\stderr.txt type .\science_apps\reference\stderr.txt >>.\testdatas\benchres.tmp
if exist .\science_apps\reference\stderr.txt echo [ /stderr ]>>.\testdatas\benchres.tmp
if exist .\science_apps\reference\work_unit.sah del .\science_apps\reference\work_unit.sah >NUL
if exist .\science_apps\reference\stderr.txt del .\science_apps\reference\stderr.txt >NUL
if %scqty% GTR 0 (
copy .\science_apps\reference\result.sah .\testDatas\ref-!refapp%%r!-!wunbr%%w!.res >NUL
echo Result      : stored as ref for validation.
) 
echo ------------
echo ------------ >>.\testdatas\benchres.tmp
)

rem :: RUNNING SCIENCE APPS IF ANY
rem :: AND COMPARE RESULTS IF REF EXISTS

:RUNSCAPPS
if "%scqty%"=="0" goto NOSCAPPS
for /L %%s IN (1,1,%SCQTY%) DO (
echo !scapp%%s! >.\testdatas\curscapp.dat
echo !wunbr%%w! >.\testdatas\curwu.dat
echo Running app : !scapp%%s! with -verb -nog
echo with WU     : !wunbr%%w!
echo !scapp%%s! / !wunbr%%w! : >>.\testdatas\benchres.tmp
if exist .\science_apps\boinc_finish_called del .\science_apps\boinc_finish_called >NUL
if exist .\science_apps\result.sah del .\science_apps\result.sah >NUL
if exist .\science_apps\state.sah del  .\science_apps\state.sah >NUL
if exist .\science_apps\stderr.txt del .\science_apps\stderr.txt
if exist .\science_apps\cpu_time.txt del .\science_apps\cpu_time.txt >NUL
copy .\testwus\!wunbr%%w! .\science_apps\work_unit.sah >NUL
copy /Y .\testwus\init_data.xml .\science_apps\init_data.xml >NUL

.\tools\NOW hh:mm:ss'.'zzz >.\Testdatas\time.tmp
for /F %%a in ('type .\Testdatas\time.tmp') do set time_tmp=%%a
echo Started at  : !time_tmp!
echo Started at  : !time_tmp! >>.\testdatas\benchres.tmp
.\tools\stopwatch start >.\Testdatas\time.dat
pushd .\science_apps\
!scapp%%s! -verb -nog
popd
.\tools\stopwatch stop < .\Testdatas\time.dat > .\Testdatas\elapsed.sec
.\tools\NOW hh:mm:ss'.'zzz >.\Testdatas\time.tmp
.\tools\wu_time .\science_apps\init_data.xml

for /F %%a in ('type .\Testdatas\time.tmp') do set time_tmp=%%a
echo Ended at    : !time_tmp!
echo Ended at    : !time_tmp! >>.\testdatas\benchres.tmp
for /F %%a in ('type .\Testdatas\elapsed.sec') do set /a elapsed_time=%%a
echo Elapsed time: !elapsed_time! seconds
echo Elapsed time: !elapsed_time! seconds >>.\testdatas\benchres.tmp
.\tools\speedup.exe !elapsed_time_stock! !elapsed_time! 2 !scapp%%s! >NUL
if exist .\testdatas\speedup.tmp type .\testdatas\speedup.tmp >>.\testdatas\timetable.tmp
.\tools\speedup.exe !elapsed_time_stock! !elapsed_time! 1 >NUL
if exist .\testdatas\speedup.tmp type .\testdatas\speedup.tmp
if exist .\testdatas\speedup.tmp type .\testdatas\speedup.tmp >>.\testdatas\benchres.tmp
if exist .\testdatas\speedup.tmp del .\testdatas\speedup.tmp >NUL

echo. >>.\testdatas\benchres.tmp

if exist .\science_apps\result.sah copy .\science_apps\result.sah .\testDatas\result-!scapp%%s!-!wunbr%%w!.res >NUL
if exist .\testDatas\ref*!wunbr%%w!.res call .\tools\validate.cmd
if not exist .\science_apps\stderr.txt echo Stderr.txt  : not found >>.\testdatas\benchres.tmp
if exist .\science_apps\stderr.txt echo [ stderr ] >>.\testdatas\benchres.tmp
if exist .\science_apps\stderr.txt type .\science_apps\stderr.txt >>.\testdatas\benchres.tmp
if exist .\science_apps\stderr.txt echo [ /stderr ] >>.\testdatas\benchres.tmp
if exist .\science_apps\stderr.txt echo. >>.\testdatas\benchres.tmp

echo ------------
echo. >>.\testdatas\benchres.tmp
echo ------------ >>.\testdatas\benchres.tmp
echo. >>.\testdatas\benchres.tmp
)
echo. >>.\testdatas\timetable.tmp
)


:::: COLLECTING HARDWARE/OS INFOS

:HWOSINFO
echo.
if exist .\testdatas\timetable.tmp echo Quick timetable >>.\testdatas\benchres.tmp
if exist .\testdatas\timetable.tmp echo. >>.\testdatas\benchres.tmp
if exist .\testdatas\timetable.tmp type .\testdatas\timetable.tmp >>.\testdatas\benchres.tmp
if exist .\testdatas\timetable.tmp echo ------------ >>.\testdatas\benchres.tmp
echo Collecting hardware / OS infos, please wait...
pushd .\Testdatas\
..\tools\cpuz -txt=report
echo Sorting ...

echo CPU: >>benchres.tmp
for %%a IN ("Number of processors" "Number of cores" "Specification" "Codename" "Instructions Sets" "Core Speed" "Core Stepping" "Technology" "Stock frequency" "Clock multiplier" "Front Side Bus Frequency" "Rated Bus Speed" "L1 Data Cache" "L2 Cache" "L3 Cache") do ..\tools\grep -m 1 -s -U %%a report.txt >>benchres.tmp
echo ------------ >>benchres.tmp

echo Chipset: >>benchres.tmp
for %%a IN ("Northbridge" "Southbridge") do ..\tools\grep -m 1 -s -U %%a report.txt >>benchres.tmp
echo ------------ >>benchres.tmp

echo RAM: >>benchres.tmp
for %%a IN ("Memory Type" "Memory Size" "Memory Frequency" "Max bandwidth" "CAS#" "RAS# to CAS#	" "RAS# Precharge" "Cycle Time (tRAS)" "DRAM Idle Timer" "Performance Mode") do ..\tools\grep -m 1 -s -U %%a report.txt >>benchres.tmp
echo ------------ >>benchres.tmp

echo OS: >>benchres.tmp
..\tools\grep -m 1 -s -U "Windows Version" report.txt >>benchres.tmp
echo ============ >>benchres.tmp
del report.txt >NUL

:::: WRITING FINAL RESULTS

for /F "tokens=1-4 delims=/- " %%A in ('date/T') do set D=%%A%%B%%C%%D
for /F "tokens=1-3 delims=:., " %%a in ("%TIME%") do set T=%%a%%b
set DTFN=%D%-%T%-%computername%-bench
ren benchres.tmp "%DTFN%".txt
if %errorlevel% GTR 0 goto DTPB
echo.
echo Bench results file %DTFN%.txt
echo stored in Knabench\Testdatas\ directory.
echo.
echo Quick timetable
echo.
type .\timetable.tmp
del .\timetable.tmp >NUL
popd

echo.
echo ======================================
 
:END
echo.

:::: RESTARTING BOINC

Echo Restarting Boinc...
net start boinc
goto EOF

:::: NT4 WARNING

:NT4
type .\tools\bel.dat
echo.
echo    IT SEEMS YOU USE NT VERSION 4 !
echo Unfortunately, this script can't work
echo properly with NT4, as it require some
echo enhanced capabilities of the CMD.EXE
echo provided with Windows 2000 or newer.
echo.
echo Good news however, these new CMD.EXE
echo seems to works well with NT4 for our
echo purpose :-)
echo But due to copyright, I can't provide 
echo one with this package.
echo.
echo If you can get one, copy it to your
echo Knabench directory, same thing for the
echo NT4BENCH.CMD file provided in \Tools
echo subdir.
echo Now you can run NT4BENCH script, that
echo will automaticaly run the benchmark
echo using the enhanced command processor.
echo.
pause
goto EOF

:::: CREATING RESULT FILE PROBLEM

:DTPB
popd
type .\tools\bel.dat
echo.
echo Oooops.. Problem occurs when trying
echo to rename the temporary results file
echo to %DTFN%.txt,
echo that MUST NOT contain any : or / in
echo its name. In this case, please consult
echo the README.
echo Also the filename may already exists,
echo if previous one were created less than
echo one minute ago.
echo Please try again later :)
echo. 
echo Temporary results may however be avai-
echo lable in .\testdatas\benchres.tmp file.

echo.
pause
goto END

:::: LOONEY TUNES LIKE ;)

:EOF
echo ========== That's all folks ==========
echo.

:::: UNATTENDED MODE
:::: For this behavior, please add/remove ::
:::: to the beginning of the following pause
:::: command to desactivate/activate it.

pause
